%example 5.3
clear, clc
D0alpha = .0062;
D0gamma = .23;
Qalpha=80000;
Qgamma= 148000;
R= 8.314;
T=(500-275):5:(1000-275);
%convert T from C to K
T=T+273;
%calc the diffusivity
Dalpha = D0alpha*exp(-Qalpha./(R*T));
Dgamma = D0gamma*exp(-Qgamma./(R*T));
%plot results
subplot (2,1,1)
semilogx(1./T,Dalpha, 1./T,Dgamma)
title('Diffusivity of Cin K')
xlabel ('Inverse temperature, K^{-1}'),
ylabel ('Diffusivity, cm^2/s')
grid on
subplot (2,1,2)
semilogy(1./T,Dalpha, 1./T,Dgamma)
axis ([])
title('Diffusivity of Cin K')
xlabel ('Inverse temperature, K^{-1}'),
ylabel ('Diffusivity, cm^2/s')
grid on
figure (2)
subplot (2,1,1)
plot(1./T,Dalpha, 1./T,Dgamma)
title('Diffusivity of Cin K')
xlabel ('Inverse temperature, K^{-1}'),
ylabel ('Diffusivity, cm^2/s')
grid on
subplot (2,1,2)
loglog(1./T,Dalpha, 1./T,Dgamma)
title('Diffusivity of Cin K')
xlabel ('Inverse temperature, K^{-1}'),
ylabel ('Diffusivity, cm^2/s')
grid on

